import React, { useEffect } from "react";
import { MapContainer, TileLayer, LayersControl, Marker, Popup, GeoJSON } from "react-leaflet";
import { GeoJsonObject } from 'geojson';
import { } from "leaflet";
import "leaflet/dist/leaflet.css";
import geos from "./sancristobal.json";
import d01 from "./d01.json";
import d02 from "./d02.json";
import d03 from "./d03.json";
import d00 from "./d00.json";



const sncr = {
    "type": "Feature",
    "properties": {},
    "geometry": geos
};

const dis00 = {    
    "type": "Feature",
    "properties": {},
    "geometry": d00
};

const dis01 = {    
    "type": "Feature",
    "properties": {},
    "geometry": d01
};

const dis02 = {
    "type": "Feature",
    "properties": {},
    "geometry": d02
};
const dis03 = {
    "type": "Feature",
    "properties": {},
    "geometry": d03
};

const isla = {
    "type": "Feature",
    "properties": {},
    "geometry": {
        "type": "Polygon",
        "coordinates": [
            [   
                [-71.6416468885807,17.4796903387122],[-71.6412505926607,17.4791976269711],
                [-71.6407308865462,17.4791422885635],[-71.6407270836224,17.4791335877686],
                [-71.6406697553112,17.479002424986],[-71.6405033796741,17.4787983903256],
                [-71.6403845400173,17.4787077082107],[-71.6400993240204,17.4785263424548],
                [-71.6399804841292,17.4784129899234],[-71.6395526605655,17.478254295715],
                [-71.6391723731732,17.4781182712494],[-71.6390059962286,17.4779595771291],
                [-71.6388158525669,17.477778211411], [-71.6385544051967,17.477710199579],
                [-71.6380315100764,17.4776421880017], [-71.6378651348873,17.4776421883747],
                [-71.6376036866069,17.477619517371], [-71.6373422394506,17.4775288345855],
                [-71.6368668801776,17.4773928103505], [-71.6368193438878,17.4772341142951],
                [-71.6368431116762,17.4770527480516], [-71.6369144159248,17.4768487110185],
                [-71.6369381833845,17.4765313191949], [-71.6369381840986,17.4762819399963],
                [-71.6366767357132,17.4761005726254], [-71.6364628244005,17.4759418763551],
                [-71.6364390559307,17.4757151684041], [-71.6365009620912,17.4755865218011],
                [-71.6365039666051,17.4755802781471], [-71.6365103601958,17.4754884586072],
                [-71.636510359915,17.4752617486144], [-71.6366054309813,17.4751710642248],
                [-71.6367955751549,17.4751937350894], [-71.6369144145683,17.4752844198801],
                [-71.6370330094786,17.4751524448012], [-71.6370387539849,17.4751460522646],
                [-71.637057022976,17.4751257223716], [-71.6373184703381,17.4750350382591],
                [-71.6375799189959,17.4748309993446], [-71.6377700624158,17.474581617349],
                [-71.6379364390408,17.4742415504177], [-71.6377700624913,17.4742642214265],
                [-71.6373422397436,17.4743775775357], [-71.6370570226247,17.4744909329616],
                [-71.637009487167,17.4746949723709], [-71.6367480390813,17.4746269593369],
                [-71.6365816629653,17.4744909326719], [-71.6364628229999,17.4745362750579],
                [-71.6363202152725,17.4744229199154], [-71.6363202153813,17.4741962071604],
                [-71.6362489119071,17.4740601802369], [-71.6360587676912,17.4738788109995],
                [-71.6361538393348,17.4737881268694], [-71.6362726797444,17.4736974416134],
                [-71.6364152878712,17.4735840850166], [-71.6366054326666,17.4734933998991],
                [-71.6367242721883,17.4733120300712], [-71.6367242722153,17.4731306595397],
                [-71.6366054320948,17.4729266189837], [-71.6364152880289,17.4727679201632],
                [-71.6363558420602,17.4725587806897], [-71.6363443849003,17.4725184736975],
                [-71.6360825372937,17.4723825073554], [-71.6357497847446,17.4724051791774],
                [-71.6356476242213,17.4722659689266], [-71.6356469380541,17.4722650339124],
                [-71.6355834088589,17.4721784650675], [-71.6357260173656,17.4720651081365],
                [-71.6358448580081,17.4719064081075], [-71.6358448581453,17.4717477085552],
                [-71.6361063054721,17.4716796940223], [-71.6362726813365,17.4718610654787],
                [-71.6363439858209,17.472087779609], [-71.6367005047483,17.4723825074034],
                [-71.6368668808137,17.4725412071095], [-71.6369868139175,17.4726174736631],
                [-71.6369905007826,17.4726198181686], [-71.6372234000012,17.4727679204879],
                [-71.6374610805848,17.4727452482833], [-71.6376340808233,17.47253950365],
                [-71.6377694779998,17.4725223901962], [-71.6377697703246,17.4725218091521],
                [-71.6378160189147,17.4724298823719], [-71.6379734724495,17.4722822981573],
                [-71.6379778910799,17.472283007152], [-71.6381741182324,17.472314492933],
                [-71.638435566315,17.4723371641068], [-71.6386732455906,17.4724731925056],
                [-71.6388396216202,17.4724731920132], [-71.6388396221226,17.4722691497541],
                [-71.6390059973701,17.4721784640197], [-71.6391723739266,17.472065107091],
                [-71.6392674461988,17.4718383936118], [-71.6393149824907,17.4716343503868],
                [-71.6393149820588,17.471452979246], [-71.6393387504313,17.471339621652],
                [-71.6396715006708,17.471407635542], [-71.6398616446231,17.4714756496073],
                [-71.640028020422,17.4713396210618], [-71.6401468603627,17.4711809207684],
                [-71.6402419317261,17.4710675631312], [-71.6405509154447,17.4709995481306],
                [-71.6405984515612,17.4712716064826], [-71.6408123638801,17.4714756496542],
                [-71.6408598997444,17.4711809203448], [-71.6408598997139,17.470999548475],
                [-71.6407410594409,17.4708181763758], [-71.6407098581712,17.4707586509036],
                [-71.6407070457787,17.4707532856585], [-71.6406459878316,17.4706368044144],
                [-71.6409549712041,17.470591460827], [-71.6412639550769,17.4707728333606],
                [-71.6412401867014,17.4709088620638], [-71.6412581410027,17.4709362457147],
                [-71.6412609414467,17.4709405169124], [-71.6414065631987,17.4711129060237],
                [-71.641525402811,17.4711809207089], [-71.6416917785114,17.4712489355419],
                [-71.6420720670252,17.4712942781002], [-71.6421909065594,17.4712942784031],
                [-71.6424523540619,17.4712942788121], [-71.6426424977632,17.4713396218051],
                [-71.6427613372627,17.471543665305], [-71.6428088731893,17.4717930516988],
                [-71.6429514813522,17.4718383943687], [-71.6431653925393,17.4717930509401],
                [-71.6432604650961,17.4715890080523], [-71.6431653932343,17.4714983225577],
                [-71.6429752486756,17.471362293406], [-71.6428801773505,17.4712035929233],
                [-71.64299901681,17.4709315344274], [-71.6430465529992,17.4708408476333],
                [-71.6432366966313,17.4707501614069], [-71.6433911708561,17.4706697898991],
                [-71.6433972201676,17.4706666424556], [-71.6434981442701,17.4706141318596],
                [-71.6437358241069,17.4706368044795], [-71.6440685757198,17.4707728338132],
                [-71.6441874161289,17.4709315352442], [-71.644448863042,17.4709995496365],
                [-71.6444726313803,17.471203591829], [-71.6441636479801,17.4713622931223],
                [-71.6439735038915,17.4717023647032], [-71.6439443030972,17.4717413600111],
                [-71.6439410121726,17.471745754775], [-71.6438546644868,17.4718610651105],
                [-71.6437595925248,17.4720651073047], [-71.6440335084185,17.4722275442682],
                [-71.6440393610775,17.4722239536327], [-71.6441874152329,17.4721331216495],
                [-71.6443537918269,17.4720424362564], [-71.6444013276562,17.4721784643865],
                [-71.6444488638069,17.4723598353457], [-71.6446390075334,17.4723371642072],
                [-71.6448529190325,17.4720877792995], [-71.6449004548052,17.4722918210742],
                [-71.6446627747342,17.4725638772957], [-71.6446451212187,17.4726733313439],
                [-71.6446440559762,17.4726799359816], [-71.6446152394304,17.4728586049706],
                [-71.644829150825,17.4730173037922], [-71.6452094383482,17.4731533326755],
                [-71.6453995823677,17.473357373024], [-71.6457561020854,17.4736974414717],
                [-71.6460650850587,17.4738788106845],                                    [-71.6462074494167,17.4739059696925],
                [-71.6462151426795,17.4739074373485],                                    [-71.6464216051313,17.4739468245184],
                [-71.6465404445772,17.4741281931463],                                    [-71.6468731978714,17.4741735356471],
                [-71.6470158057664,17.4744455888887],                                    [-71.6468731960673,17.4746949708022],
                [-71.646707782993,17.4749027394547],                                    [-71.6467075935347,17.4749029774255],
                [-71.6465879809056,17.4751257215758],                                    [-71.6466117489328,17.4753751022601],
                [-71.6466830530471,17.4757151673739],                                    [-71.6469920367612,17.4759872183001],
                [-71.6469920366701,17.4758965345768],                                    [-71.6470633400945,17.4756924962148],
                [-71.6472297164979,17.4755791418008],                                    [-71.6472759886251,17.4755854466981],
                [-71.6472841393896,17.4755865573777],                                    [-71.6473960921369,17.4756018128357],
                [-71.6474928141668,17.4759355327516],                                    [-71.6474998535287,17.4759598206304],
                [-71.6475862352822,17.4761685861067],                                    [-71.647774610512,17.4764115152977],
                [-71.6478700494903,17.4767583239362],                                    [-71.6478952456339,17.4768367868963],
                [-71.647942755266,17.4769847358888],                                    [-71.6479517723518,17.4771878342831],
                [-71.6479548980302,17.4772582361622],                                    [-71.6479639144499,17.477274055199],
                [-71.6481091312508,17.4775288335116],                                    [-71.6480615942303,17.4778688941947],
                [-71.6479902906658,17.4782089547105],                                    [-71.6478952178736,17.4785263432692],
                [-71.6478001460926,17.4788890718225],                                    [-71.6475386991004,17.479206459986],
                [-71.6469920361478,17.4794331650363],                                    [-71.646397836388,17.4795238461293],
                [-71.6459700120278,17.4795691872036],                                    [-71.6454708846965,17.4795691878048],
                [-71.6450668295499,17.4795691872795],                                    [-71.6447340790532,17.4795691865891],
                [-71.6441636470606,17.4795238458168],                                    [-71.6438546641224,17.4796598682566],
                [-71.6437120563708,17.4799545835056],                                    [-71.6435219111534,17.4801359470541],
                [-71.6432604631614,17.4802946401359],                                    [-71.6429322514162,17.4803428771424],
                [-71.6429287475438,17.4803433921034],                                    [-71.642824226923,17.4803722484953],
                [-71.6428186660111,17.4803737837698],                                    [-71.6427080991434,17.4803585346074],
                [-71.6425486034036,17.4803365362139],                                    [-71.6424231742919,17.4803141937449],
                [-71.6423352710796,17.480298535376],                                    [-71.6421499116379,17.4802329340527],
                [-71.6419781455768,17.4801263117758],                                    [-71.6418345481978,17.48000570104]
            ]
        ]
    }
};

const setMap = (map: any) => {
    const resizeObserver = new ResizeObserver(() => {
        map.invalidateSize()
    })
    const container = document.getElementById('map-container')
    resizeObserver.observe(container!)
}

export default function Mapa() {

    return (
        <MapContainer center={[18.414349, -70.107011]}
            zoom={10}
            dragging={true}
            keyboard={false}
            scrollWheelZoom={true}
            attributionControl={false}
            style={{ height: '100vh', width: '100wh' }}
        >
            <TileLayer
                attribution='&copy; <a href="https://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors'
                url="https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png"
            />
            <LayersControl position="topright">
                <LayersControl.Overlay name="Pais">
                    <GeoJSON key="pais01" data={isla as GeoJsonObject} ></GeoJSON>
                    
                </LayersControl.Overlay>
                <LayersControl.Overlay name="Region">
                    <Marker position={[18.415349, -70.107011]}>
                        <Popup>
                            A pretty CSS3 popup. <br /> Easily customizable.
                        </Popup>
                    </Marker>
                </LayersControl.Overlay>
                <LayersControl.Overlay name="Provincia">
                    <GeoJSON key="prov01" data={sncr as GeoJsonObject} ></GeoJSON>
                </LayersControl.Overlay>
                <LayersControl.Overlay name="Distrito">
                    <GeoJSON key="d00" data={dis00 as GeoJsonObject} ></GeoJSON>
                </LayersControl.Overlay>
            </LayersControl>
        </MapContainer>
    );
}